using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Collections;
using System.IO;
using PaintDotNet.Effects;
using PaintDotNet;


namespace TRsFuego
{
    public class EffectPluginConfigDialog : PaintDotNet.Effects.EffectConfigDialog
    {
        private bool saver = false;

        private Bitmap Bmp;
        private Bitmap LargeBmp;
        private Bitmap bg;
        private Bitmap Fire;

        private Rectangle MyBounds = new Rectangle();
        private Point PanBase = new Point();
        bool PanFlag = false;
        bool SetFlag = false;
        bool MoveFlag = false;
        bool RenderFlag = false;
        private Point premotion = new Point();
        private Point fixmotion = new Point();
        Random rndm = new Random((int)Guid.NewGuid().GetHashCode());

        Point[] triad = new Point[4];
        int triadcount = 0;
        int triadselect = 0;

        private ProgressBar progressBar1;
        private Panel PreviewPanel;
        private HScrollBar DensityVal;
        private Label ScrollNum;
        private CheckBox zoom2;
        private Button Render;
        private Button ClrButton;
        private Label turbnum;
        private HScrollBar turbulenceVal;
        private Label windnum;
        private HScrollBar windVal;
        private Panel panel1;
        private HScrollBar ShapeVal;
        private Label shapeNum;
        private Button buttonOK;

        public EffectPluginConfigDialog()
        {
            InitializeComponent();
        }

        protected override void InitialInitToken()
        {
            theEffectToken = new EffectPluginConfigToken(false,500,0,500,250);
        }

        
        protected override void InitTokenFromDialog()
        {
            EffectPluginConfigToken token = (EffectPluginConfigToken)base.theEffectToken;
            token.Save = saver;
            token.Turbulence = turbulenceVal.Value;
            token.Thickness = DensityVal.Value;
            token.Wind = windVal.Value;
            token.Shape = ShapeVal.Value;
        }

        protected override void InitDialogFromToken(EffectConfigToken effectToken)
        {
             EffectPluginConfigToken token = (EffectPluginConfigToken)effectToken;
             turbulenceVal.Value = token.Turbulence;
             DensityVal.Value = token.Thickness;
             windVal.Value = token.Wind;
             ShapeVal.Value = token.Shape;
        }

        private void InitializeComponent()
        {
            this.buttonOK = new System.Windows.Forms.Button();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.DensityVal = new System.Windows.Forms.HScrollBar();
            this.PreviewPanel = new System.Windows.Forms.Panel();
            this.ScrollNum = new System.Windows.Forms.Label();
            this.zoom2 = new System.Windows.Forms.CheckBox();
            this.Render = new System.Windows.Forms.Button();
            this.ClrButton = new System.Windows.Forms.Button();
            this.turbnum = new System.Windows.Forms.Label();
            this.turbulenceVal = new System.Windows.Forms.HScrollBar();
            this.windnum = new System.Windows.Forms.Label();
            this.windVal = new System.Windows.Forms.HScrollBar();
            this.panel1 = new System.Windows.Forms.Panel();
            this.ShapeVal = new System.Windows.Forms.HScrollBar();
            this.shapeNum = new System.Windows.Forms.Label();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // buttonOK
            // 
            this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonOK.Location = new System.Drawing.Point(688, 26);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(67, 23);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.UseVisualStyleBackColor = true;
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            // 
            // progressBar1
            // 
            this.progressBar1.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.progressBar1.Location = new System.Drawing.Point(94, 3);
            this.progressBar1.Maximum = 1000;
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(551, 13);
            this.progressBar1.TabIndex = 3;
            // 
            // DensityVal
            // 
            this.DensityVal.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.DensityVal.LargeChange = 1;
            this.DensityVal.Location = new System.Drawing.Point(340, 41);
            this.DensityVal.Maximum = 5000;
            this.DensityVal.Minimum = 10;
            this.DensityVal.Name = "DensityVal";
            this.DensityVal.Size = new System.Drawing.Size(216, 14);
            this.DensityVal.TabIndex = 5;
            this.DensityVal.Value = 500;
            this.DensityVal.Scroll += new System.Windows.Forms.ScrollEventHandler(this.Slider_Scroll);
            this.DensityVal.ValueChanged += new System.EventHandler(this.DensityVal_ValueChanged);
            // 
            // PreviewPanel
            // 
            this.PreviewPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.PreviewPanel.BackColor = System.Drawing.Color.Transparent;
            this.PreviewPanel.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.PreviewPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.PreviewPanel.Location = new System.Drawing.Point(12, 12);
            this.PreviewPanel.Name = "PreviewPanel";
            this.PreviewPanel.Size = new System.Drawing.Size(770, 189);
            this.PreviewPanel.TabIndex = 4;
            this.PreviewPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.PreviewPanel_Paint);
            this.PreviewPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseDown);
            this.PreviewPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseMove);
            this.PreviewPanel.MouseUp += new System.Windows.Forms.MouseEventHandler(this.PreviewPanel_MouseUp);
            // 
            // ScrollNum
            // 
            this.ScrollNum.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ScrollNum.BackColor = System.Drawing.Color.Transparent;
            this.ScrollNum.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ScrollNum.ForeColor = System.Drawing.Color.Gold;
            this.ScrollNum.Location = new System.Drawing.Point(559, 41);
            this.ScrollNum.Name = "ScrollNum";
            this.ScrollNum.Size = new System.Drawing.Size(113, 15);
            this.ScrollNum.TabIndex = 6;
            this.ScrollNum.Text = "Flame Density 500";
            this.ScrollNum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // zoom2
            // 
            this.zoom2.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.zoom2.AutoSize = true;
            this.zoom2.ForeColor = System.Drawing.Color.Gold;
            this.zoom2.Location = new System.Drawing.Point(688, 3);
            this.zoom2.Name = "zoom2";
            this.zoom2.Size = new System.Drawing.Size(69, 17);
            this.zoom2.TabIndex = 7;
            this.zoom2.Text = "Zoom 2X";
            this.zoom2.UseVisualStyleBackColor = true;
            // 
            // Render
            // 
            this.Render.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.Render.Location = new System.Drawing.Point(14, 3);
            this.Render.Name = "Render";
            this.Render.Size = new System.Drawing.Size(65, 23);
            this.Render.TabIndex = 8;
            this.Render.Text = "Render";
            this.Render.UseVisualStyleBackColor = true;
            this.Render.Click += new System.EventHandler(this.Render_Click);
            // 
            // ClrButton
            // 
            this.ClrButton.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ClrButton.Location = new System.Drawing.Point(14, 32);
            this.ClrButton.Name = "ClrButton";
            this.ClrButton.Size = new System.Drawing.Size(65, 23);
            this.ClrButton.TabIndex = 8;
            this.ClrButton.Text = "Clear";
            this.ClrButton.UseVisualStyleBackColor = true;
            this.ClrButton.Click += new System.EventHandler(this.ClrButton_Click);
            // 
            // turbnum
            // 
            this.turbnum.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.turbnum.BackColor = System.Drawing.Color.Transparent;
            this.turbnum.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.turbnum.ForeColor = System.Drawing.Color.Gold;
            this.turbnum.Location = new System.Drawing.Point(237, 19);
            this.turbnum.Name = "turbnum";
            this.turbnum.Size = new System.Drawing.Size(89, 15);
            this.turbnum.TabIndex = 10;
            this.turbnum.Text = "Turbulence 500";
            this.turbnum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // turbulenceVal
            // 
            this.turbulenceVal.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.turbulenceVal.LargeChange = 1;
            this.turbulenceVal.Location = new System.Drawing.Point(94, 19);
            this.turbulenceVal.Maximum = 1000;
            this.turbulenceVal.Name = "turbulenceVal";
            this.turbulenceVal.Size = new System.Drawing.Size(140, 15);
            this.turbulenceVal.TabIndex = 9;
            this.turbulenceVal.Value = 500;
            this.turbulenceVal.Scroll += new System.Windows.Forms.ScrollEventHandler(this.Slider_Scroll);
            this.turbulenceVal.ValueChanged += new System.EventHandler(this.turbulenceVal_ValueChanged);
            // 
            // windnum
            // 
            this.windnum.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.windnum.BackColor = System.Drawing.Color.Transparent;
            this.windnum.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.windnum.ForeColor = System.Drawing.Color.Gold;
            this.windnum.Location = new System.Drawing.Point(237, 41);
            this.windnum.Name = "windnum";
            this.windnum.Size = new System.Drawing.Size(63, 15);
            this.windnum.TabIndex = 12;
            this.windnum.Text = "Wind 0";
            this.windnum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // windVal
            // 
            this.windVal.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.windVal.LargeChange = 1;
            this.windVal.Location = new System.Drawing.Point(94, 40);
            this.windVal.Maximum = 10;
            this.windVal.Minimum = -10;
            this.windVal.Name = "windVal";
            this.windVal.Size = new System.Drawing.Size(140, 15);
            this.windVal.TabIndex = 11;
            this.windVal.Scroll += new System.Windows.Forms.ScrollEventHandler(this.Slider_Scroll);
            this.windVal.ValueChanged += new System.EventHandler(this.windVal_ValueChanged);
            // 
            // panel1
            // 
            this.panel1.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.panel1.BackColor = System.Drawing.Color.Firebrick;
            this.panel1.Controls.Add(this.ClrButton);
            this.panel1.Controls.Add(this.windVal);
            this.panel1.Controls.Add(this.windnum);
            this.panel1.Controls.Add(this.buttonOK);
            this.panel1.Controls.Add(this.turbulenceVal);
            this.panel1.Controls.Add(this.turbnum);
            this.panel1.Controls.Add(this.Render);
            this.panel1.Controls.Add(this.ShapeVal);
            this.panel1.Controls.Add(this.DensityVal);
            this.panel1.Controls.Add(this.zoom2);
            this.panel1.Controls.Add(this.progressBar1);
            this.panel1.Controls.Add(this.shapeNum);
            this.panel1.Controls.Add(this.ScrollNum);
            this.panel1.Location = new System.Drawing.Point(12, 207);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(770, 60);
            this.panel1.TabIndex = 13;
            this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
            // 
            // ShapeVal
            // 
            this.ShapeVal.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ShapeVal.LargeChange = 1;
            this.ShapeVal.Location = new System.Drawing.Point(340, 19);
            this.ShapeVal.Maximum = 1000;
            this.ShapeVal.Name = "ShapeVal";
            this.ShapeVal.Size = new System.Drawing.Size(216, 15);
            this.ShapeVal.TabIndex = 5;
            this.ShapeVal.Value = 250;
            this.ShapeVal.Scroll += new System.Windows.Forms.ScrollEventHandler(this.Slider_Scroll);
            this.ShapeVal.ValueChanged += new System.EventHandler(this.ShapeVal_ValueChanged);
            // 
            // shapeNum
            // 
            this.shapeNum.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.shapeNum.BackColor = System.Drawing.Color.Transparent;
            this.shapeNum.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.shapeNum.ForeColor = System.Drawing.Color.Gold;
            this.shapeNum.Location = new System.Drawing.Point(559, 19);
            this.shapeNum.Name = "shapeNum";
            this.shapeNum.Size = new System.Drawing.Size(86, 15);
            this.shapeNum.TabIndex = 6;
            this.shapeNum.Text = "Shape 250";
            this.shapeNum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // EffectPluginConfigDialog
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.BackColor = System.Drawing.Color.Gray;
            this.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.ClientSize = new System.Drawing.Size(794, 272);
            this.Controls.Add(this.PreviewPanel);
            this.Controls.Add(this.panel1);
            this.Location = new System.Drawing.Point(0, 0);
            this.Name = "EffectPluginConfigDialog";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "TR\'s EFX";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.EffectPluginConfigDialog_Load);
            this.Controls.SetChildIndex(this.panel1, 0);
            this.Controls.SetChildIndex(this.PreviewPanel, 0);
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.ResumeLayout(false);

        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            DensityVal.Enabled = false;
            buttonOK.Enabled = false;
            saver = true;
            DrawGraphics(false);
            Bmp.Save(Path.GetTempPath() + @"TRFUEGO.bmp");
            FinishTokenUpdate();
            DialogResult = DialogResult.OK;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void reload()
        {
            MyBounds = EffectSourceSurface.Bounds;
            Bitmap bm = new RenderArgs(EffectSourceSurface).Bitmap;
            Bmp = new Bitmap(bm.Width, bm.Height);
            LargeBmp = new Bitmap(bm.Width, bm.Height);
            Fire = new Bitmap(bm.Width, bm.Height);
            Graphics g = Graphics.FromImage(LargeBmp);
            g.DrawImage(bm, 0, 0);
            bm.Dispose();
            g.Dispose();

            
            //checkerboard
            bg = new Bitmap(MyBounds.Width, MyBounds.Height);
            Surface tmp = new Surface(EffectSourceSurface.Size);
            tmp.ClearWithCheckerboardPattern();
            Bitmap b = new RenderArgs(tmp).Bitmap;
            Graphics g1 = Graphics.FromImage(bg);
            g1.DrawImage(b, 0, 0);
            g1.Dispose();
            tmp.Dispose();
            GC.Collect();
        }

        private void EffectPluginConfigDialog_Load(object sender, EventArgs e)
        {
            reload();
            if (PreviewPanel.Width >= MyBounds.Width)
            {
                PreviewPanel.Width = MyBounds.Width;
                PreviewPanel.Left = (this.ClientRectangle.Width - PreviewPanel.Width) / 2;

            }

            if (PreviewPanel.Height >= MyBounds.Height) PreviewPanel.Height = MyBounds.Height;

            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            this.Text = EffectPlugin.StaticName + " ver. " + version.Major + "." + version.Minor + "." + version.Build;

        }


        private void DrawGraphics(bool preview)
        {
            try
            {
                Bitmap basebmp = new Bitmap(MyBounds.Width, MyBounds.Height);
                Graphics b = Graphics.FromImage(basebmp);
                b.CompositingMode = CompositingMode.SourceOver;
                b.SmoothingMode = SmoothingMode.AntiAlias;


                //add Checker layer
                if (preview)b.DrawImage(bg, 0, 0);

                //add image layer
                b.DrawImage(LargeBmp, 0, 0);

                if (RenderFlag) b.DrawImage(Fire, 0, 0);

                //add overlay
                if (preview && !RenderFlag)
                {
                    for (int i = 0; i < triadcount; i++)
                    {
                        if (i < 3)
                        {
                            Pen p = new Pen(Color.Yellow);
                            p.Width = 3;
                            b.DrawEllipse(p, triad[i].X - 5, triad[i].Y - 5, 10, 10);
                            p.Dispose();
                        }
                    }
                    Pen p2 = new Pen(Color.Yellow);
                    p2.Width = 3;
                    if (triadcount > 1) b.DrawLine(p2, triad[0], triad[1]);
                    if (triadcount > 2) b.DrawLine(p2, triad[2], triad[3]);

                }



                //draw on screen
                if (preview)
                {
                    Graphics g = PreviewPanel.CreateGraphics();
                    g.CompositingMode = CompositingMode.SourceOver;
                    if (zoom2.Checked)
                    {
                        g.DrawImage(basebmp, PreviewPanel.ClientRectangle, PanBase.X, PanBase.Y, PreviewPanel.Bounds.Width / 2,
                            PreviewPanel.Bounds.Height / 2, GraphicsUnit.Pixel);
                    }
                    else
                    {
                        g.DrawImage(basebmp, PreviewPanel.ClientRectangle, PanBase.X, PanBase.Y, PreviewPanel.Bounds.Width,
                            PreviewPanel.Bounds.Height, GraphicsUnit.Pixel);
                    }
                    g.Dispose();
                }
                else
                {
                    Graphics g = Graphics.FromImage(Bmp);
                    g.CompositingMode = CompositingMode.SourceOver;
                    g.DrawImage(basebmp, 0,0);
                    g.Dispose();
                }

                b.Dispose();
                basebmp.Dispose();
            }
            catch { }
            GC.Collect();
        }

        private void PreviewPanel_Paint(object sender, PaintEventArgs e)
        {
            DrawGraphics(true);
        }

        private void PreEffect()
        {
             DensityVal.Enabled = true;
        }



        private void DensityVal_ValueChanged(object sender, EventArgs e)
        {
            ScrollNum.Text = "Flame Density " + Convert.ToString(DensityVal.Value);
        }

        protected override void WndProc(ref Message message)
        {
            const int WM_SYSCOMMAND = 0x0112;
            const int SC_MOVE = 0xF010;

            switch (message.Msg)
            {
                case WM_SYSCOMMAND:
                    int command = message.WParam.ToInt32() & 0xfff0;
                    if (command == SC_MOVE)
                        return;
                    break;
            }

            base.WndProc(ref message);
        }

        private void PreviewPanel_MouseDown(object sender, MouseEventArgs e)
        {
            Point ee = new Point(e.X, e.Y);
            if (zoom2.Checked)
            {
                ee.X /= 2;
                ee.Y /= 2;
            }

            if (SetFlag) return;

            premotion = new Point(ee.X, ee.Y);
            fixmotion = new Point(ee.X + PanBase.X, ee.Y + PanBase.Y);

            if (e.Button == MouseButtons.Right)
            {
                PanFlag = true;
            }
            else if (e.Button == MouseButtons.Left)
            {
                SetFlag = true;
                
                if (triadcount ==0)
                {
                    triad[0] = fixmotion;
                    triadcount++;
                }else if (triadcount==1){
                    triad[1] = fixmotion;
                    triadcount++;

                }else  if (triadcount == 2){
                    triad[3]=new Point((triad[0].X + triad[1].X)/2,(triad[0].Y + triad[1].Y)/2);
                    triad[2].X = triad[3].X;
                    triad[2].Y = triad[3].Y - Math.Abs(fixmotion.Y - (int)triad[3].Y);
                    triadcount=4;
                }else if (CheckNode()){
                    MoveFlag=true;
                }


                DrawGraphics(true);
                
            }

        }
        private void PreviewPanel_MouseMove(object sender, MouseEventArgs e)
        {
            Point ee = new Point(e.X, e.Y);
            if (zoom2.Checked)
            {
                ee.X /= 2;
                ee.Y /= 2;
            }
            if (MoveFlag)
            {
                if (triadselect < 2)
                {
                    int t23 = Math.Abs(triad[3].Y - triad[2].Y);
                    triad[triadselect] = new Point(ee.X + PanBase.X, ee.Y + PanBase.Y);
                    triad[3] = new Point((triad[0].X + triad[1].X) / 2, (triad[0].Y + triad[1].Y) / 2);
                    triad[2].X = triad[3].X;
                    triad[2].Y = triad[3].Y - t23;
                }
                else
                {
                    triad[2].Y = triad[3].Y - Math.Abs((ee.Y + PanBase.Y) - (int)triad[3].Y);
                }
            }
            if (PanFlag)
            {

                Point motion = new Point(ee.X, ee.Y);
                int movex = premotion.X - motion.X + PanBase.X;
                premotion.X = motion.X;
                int movey = premotion.Y - motion.Y + PanBase.Y;
                premotion.Y = motion.Y;

                PanBounds(movex, movey);
            }
            DrawGraphics(true);
        }
        private void PreviewPanel_MouseUp(object sender, MouseEventArgs e)
        {
            SetFlag = false;
            PanFlag = false;
            MoveFlag = false;
            DrawGraphics(true);

        }

        private void PanBounds(int movex, int movey)
        {
            if (zoom2.Checked)
            {
                PanBase.X = MyUtils.clamp(movex, 0, MyBounds.Width - PreviewPanel.Width / 2);
                PanBase.Y = MyUtils.clamp(movey, 0, MyBounds.Height - PreviewPanel.Height / 2);
            }
            else
            {
                PanBase.X = MyUtils.clamp(movex, 0, MyBounds.Width - PreviewPanel.Width);
                PanBase.Y = MyUtils.clamp(movey, 0, MyBounds.Height - PreviewPanel.Height);
            }
        }

        private void ClrButton_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage(Fire);
            g.Clear(Color.Transparent);
            g.Dispose();
            RenderFlag = false;
            DrawGraphics(true);
        }

        private void lockControls(bool setval)
        {
            turbulenceVal.Enabled = setval;
            windVal.Enabled = setval;
            ShapeVal.Enabled = setval;
            DensityVal.Enabled = setval;
            zoom2.Enabled = setval;
        }

        private unsafe void Render_Flames()
        {
            RenderFlag = false;
            lockControls(false);
            if (triadcount<3) return;
            Graphics g = Graphics.FromImage(Fire);
            g.Clear(Color.Transparent);
            float wideval = (float)MyUtils.PythagP(triad[0], triad[1]);
            float increment = 1 / wideval;
            float incV = (float)MyUtils.PythagP(triad[3], triad[2]);

            float turb = (float)turbulenceVal.Value / 1000 * .75f + .05f;
            float halfturb = turb / 2;
            float flicks = DensityVal.Value;
            float windy =(float)windVal.Value / 10  * (wideval/2);

            float shape =((float)ShapeVal.Value / 1000 * incV *.5f + 12);

            for (float t = 0; t < flicks; t++)
            {
                float i = (float)rndm.NextDouble();
                float x = triad[1].X * i + triad[0].X - triad[0].X * i;
                float y = triad[1].Y * i + triad[0].Y - triad[0].Y * i;
                 
                PointF[] flick = new PointF[4];

                float RincV = incV * .75f + (float)rndm.NextDouble() * (incV * .25f);
                float wobbley = incV / 15 * (float)rndm.NextDouble();
                float wobblex = incV / 15 * (float)rndm.NextDouble(); 

                flick[0] = new PointF(x + wobblex, y + wobbley);
                float sway = (float)((rndm.Next(10) % 2) * 2 - 1);
                float rnd = (float)rndm.NextDouble() * sway;
                flick[1] = new PointF(x + rnd * (turb * incV) , y - RincV * .25f);
                rnd = (float)rndm.NextDouble() * (-sway);
                flick[2] = new PointF(x + rnd * (turb * incV) + windy, y - RincV * .50f);
                rnd = (float)rndm.NextDouble() * sway;
                flick[3] = new PointF(x + rnd * (turb * incV) + windy, y - RincV);

                float colorshift = (t/flicks);


                //draw flames
                for (float j = 0; j < 1; j += 1/(incV * 3))
                {

                    PointF burn = MyUtils.Bezier(flick[0], flick[1], flick[2], flick[3], j);
                    Pen ember = new Pen(Color.FromArgb((byte)(15 - j * 15), 255, (byte)(colorshift * 255), 0));
                    float fullback = shape - j * shape;
                    float halfback = shape - j * shape * .5f;
                    g.DrawEllipse(ember, burn.X - halfback, burn.Y - halfback, fullback, fullback);

                    ember.Dispose();
                }
                progressBar1.Value =(int) t * 500 / (int)flicks;
                Application.DoEvents();

            }

            g.Dispose();

            //blur it
            BitmapData bmd = Fire.LockBits(new Rectangle(0, 0, Fire.Width, Fire.Height),
                System.Drawing.Imaging.ImageLockMode.ReadWrite, Fire.PixelFormat);

            int[] offx = { -1, 0, 1, -1, 0 ,1,-1, 0, 1 };
            int[] offy = { -1, -1, -1, 0, 0, 0, 1, 1, 1 };

            byte* row = (byte*)bmd.Scan0;
            int numbytes = bmd.Height * bmd.Stride;
            for (int d =0 ; d < 2 ; d++){

                for (int y = 0; y < Fire.Height; y++)
                {

                    for (int x = 0; x < Fire.Width; x++)
                    {
                        int CA = 0;
                        int CR = 0;
                        int CG = 0;
                        int CB = 0;
                        for (int i = 0; i < 8; i++)
                        {
                            int nx = MyUtils.clamp(offx[i] + x, 0, (int)Fire.Width - 1);
                            int ny = MyUtils.clamp(offy[i] + y, 0, (int)Fire.Height - 1);
                            CA += row[ny * bmd.Stride + 4 * nx + 3];
                            CB += row[ny * bmd.Stride + 4 * nx];
                            CG += row[ny * bmd.Stride + 4 * nx + 1];
                            CR += row[ny * bmd.Stride + 4 * nx + 2];
                        }
                        row[y * bmd.Stride + 4 * x + 3] = (byte)(CA / 8);
                        row[y * bmd.Stride + 4 * x] = (byte)(CB / 8);
                        row[y * bmd.Stride + 4 * x + 1] = (byte)(CG / 8);
                        row[y * bmd.Stride + 4 * x + 2] = (byte)(CR / 8);
                    }
                    progressBar1.Value = d*y * 500 / (Fire.Height*2) + 499;
                    Application.DoEvents();

                }
            }

            Fire.UnlockBits(bmd);

            progressBar1.Value = 0;
            RenderFlag = true;
            lockControls(true);
            PreviewPanel.Refresh();
            
        }


        private void turbulenceVal_ValueChanged(object sender, EventArgs e)
        {
            turbnum.Text = "Turbulence " + Convert.ToString(turbulenceVal.Value);
        }



        private void Render_Click(object sender, EventArgs e)
        {
            Render_Flames();
        }

        private void windVal_ValueChanged(object sender, EventArgs e)
        {
            windnum.Text = "Wind " + Convert.ToString(windVal.Value);
        }

        private bool CheckNode()
        {

            if (triadcount < 3) return false;
            bool results = false;
            for (int i = 0; i < 3; i++)
            {
                if (MyUtils.PythagP(triad[i], fixmotion) <= 5)
                {
                    results = true;
                    triadselect = i;
                }

            }
            return results;
        }

        private void Slider_Scroll(object sender, ScrollEventArgs e)
        {
            if (e.Type == ScrollEventType.EndScroll)
            {
                if (RenderFlag) Render_Flames();
            }
        }

        private void ShapeVal_ValueChanged(object sender, EventArgs e)
        {
            shapeNum.Text = "Shape " + Convert.ToString(ShapeVal.Value);
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}